function r = rand_isotropic(dim)
% returns a random vector on the unit ball in dim dimensions 

if dim ~=2 && dim ~= 3
   error('not implemented for higher dimensions');
end

if dim == 2
  t = 2*pi*rand;
  r = [cos(t), sin(t)];
end

g = @(x) sin(x)/2;
f = @(x) 0.5;

if dim == 3
  phi = 2*pi*rand;

  reject = true;
  while reject
    x = pi*rand;
    y = rand;
    if y*f(x) < g(x)
       reject = false;
    end
  end 

  theta = x;
  r = [sin(theta)*cos(phi), sin(theta)*sin(phi), cos(theta)];
end
